#-*- coding: utf-8 -*-

# Copyright 2008-2010 Mir Calculate Ltd. http://www.calculate-linux.org
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import os
from cl_datavars import glob_attr
from  cl_utils import genpassword
from encrypt import encrypt

class fillVars(glob_attr):
    encryptObj = encrypt()
    addDn = lambda x,*y: ",".join(y)
    genDn = lambda x,*y: "=".join(y)

    def getHash(self, password, encrypt):
        """Получить хеш пароля

        password - пароль
        encrypt - алгоритм шифрования, например 'ssha'
        """
        hashPwd = self.encryptObj.getHashPasswd(password, encrypt.lower())
        if hashPwd:
            return hashPwd
        else:
            print "Error encrypt password, method getHash()"
            exit(1)

    def get_ld_base_dn(self):
        """базовый DN LDAP"""
        return self.genDn("dc", self.Get('ld_base_root'))

    def get_ld_bind_dn(self):
        """bind DN LDAP"""
        return self.addDn(self.genDn("cn", self.Get('ld_bind_login')),
                          self.Get('ld_base_dn'))

    def get_ld_bind_hash(self):
        """hash пароля для пользователя для чтения"""
        return self.getHash(self.Get('ld_bind_pw'), self.Get('ld_encrypt'))

    def get_ld_temp_dn(self):
        #DN временного пользователя root (для инициализации базы данных)
        return self.addDn(self.genDn("cn", "ldaproot"), self.Get('ld_base_dn'))

    def get_ld_temp_pw(self):
        """пароль временного пользователя root"""
        return genpassword()

    def get_ld_temp_hash(self):
        """hash пароля временного root"""
        return self.getHash(self.Get('ld_temp_pw'), self.Get('ld_encrypt'))

    def get_ld_admin_dn(self):
        """DN  пользователя root"""
        return self.addDn(self.genDn("cn", self.Get('ld_admin_login')), 
                          self.Get('ld_base_dn'))

    def get_ld_admin_hash(self):
        """hash пароля root"""
        return self.getHash(self.Get('ld_admin_pw'), self.Get('ld_encrypt'))

    def get_ld_admin_pw(self):
        """пароль root"""
        return genpassword()

    def get_ld_services_dn(self):
        """DN для всех сервисов"""
        return self.addDn(self.genDn("ou", self.Get('ld_services')), 
                          self.Get('ld_base_dn'))
